unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls,
  FileUtil;

type

  { TForm1 }

  TForm1 = class(TForm)
    ImageList1: TImageList;
    ListView1: TListView;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure RadioButton1Change(Sender: TObject);
    procedure RadioButton2Change(Sender: TObject);
  private
    procedure DirectoryFound(FileIterator: TFileIterator);
    procedure FileFound(FileIterator: TFileIterator);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}


{ TForm1 }

procedure TForm1.DirectoryFound(FileIterator: TFileIterator);
var
  item: TListItem;
begin
  item := ListView1.Items.Add;
  item.Caption := ExtractFileName(FileIterator.FileName);
  item.ImageIndex := 1;
end;

procedure TForm1.FileFound(FileIterator: TFileIterator);
var
  item: TListItem;
begin
  item := ListView1.Items.Add;
  item.Caption := ExtractFileName(FileIterator.FileName);
  item.ImageIndex := 0;
end;

function CompareItems(AItem1, AItem2: TListItem; AOptionalParam: PtrInt): Integer; stdcall;
var
  fn1, fn2: String;
  isFolder1, isFolder2: Boolean;
begin
  isFolder1 := AItem1.ImageIndex = 1;
  isFolder2 := AItem2.ImageIndex = 1;
  if isFolder1 and not isFolder2 then
    Result := -AOptionalParam
  else if isFolder2 and not isFolder1 then
    Result := AOptionalParam
  else begin
    fn1 := AItem1.Caption;
    fn2 := AItem2.Caption;
    Result := CompareText(fn1, fn2);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  searcher: TFileSearcher;
begin
  ForceDirectories('test');
  ForceDirectories('abc');
  searcher := TFileSearcher.Create;
  try
    searcher.OnDirectoryFound := @DirectoryFound;
    searcher.OnFileFound := @FileFound;
    searcher.Search('.', '*.*', false, false);
  finally
    searcher.Free;
  end;
end;

procedure TForm1.RadioButton1Change(Sender: TObject);
begin
  ListView1.CustomSort(@CompareItems, 1);
end;

procedure TForm1.RadioButton2Change(Sender: TObject);
begin
  ListView1.CustomSort(@compareItems, -1);
end;

end.

